#include"kj.h"
#include<fstream.h>
/*
   07 - beep
   09 - move 2 nxt tab stop horizontal
   0a - line feed (moves paper 1 in up)
   0b - move 2 nxt vertiacl tab stop
   */
class printer
{  union REGS ii,oo;
   int page;
   public:

    printer()
    {
      ii.h.ah=0x0f;
      int86(0x10,&ii,&oo);
      page= oo.h.bh;
    }
 char status(int n=0)
    {
      ii.h.ah=0x02;
      ii.x.dx=n;
      int86(0x17,&ii,&oo);
      return oo.h.ah;
    }

    int getpix(int x,int y)
    { ii.h.ah=0x0d;
      ii.x.cx=x;
      ii.x.dx=y;
      ii.h.bh=page;
      int86(0x10,&ii,&oo);
      return oo.h.al;
      }

	void cancelprint()
	{
	//putc(0x18,stdprn);
	putc(0x7f,stdprn);
	}


int printpage(int minx,int miny,int maxx,int maxy,int strt=1,int bkcol=0);
};


int printer::printpage(int minx,int miny,int maxx,int maxy,int strt,int bkcol)
{
	register int row, j, cr;
	unsigned int bit,col;
	char pd,chr,ch;
	chr = status(0);
	if(chr&1)return 0; //time out
	if(!(chr&64))return 0; //prn not connected
	   if(chr&32)return 0;     //prn out of papr

			if(kbhit())
			{
			 ch=getch();
			 if(ch==0x1b){cancelprint();return 0;}
			}

	if(strt)
	{
	putc(0x0c,stdprn);
	putc(0x0a,stdprn);
	putc(0x0a,stdprn);
	putc(0x0a,stdprn);
	}
	putc(0x0a,stdprn);
	putc(0x0d,stdprn);
	putc(0x1b,stdprn);
	putc(0x41,stdprn);
	putc(0x08,stdprn);	/* 8/72 lines per inch */
	for(cr=minx; cr<maxx; cr += 8)
	{			/* Column loop */
		putc(0x09,stdprn);						/* Tab to column and begin dump */
		putc(0x1b,stdprn);
		putc(0x4c,stdprn);
		putc(48,stdprn);
		putc(3,stdprn); /* 960 mode next 816 */

		for(row=maxy; row>=miny; row--) {		/* Row loop */
			//cout<<"\n"<<row;
			chr = 0;						/* Initialize graphics character */
			bit = 0x80;						/* Initialize bit mask */
			if(kbhit())
			{
			 ch=getch();
			 if(ch==0x1b){cancelprint();return 0;}
			}

			for(j=0; j<8; j++)
			{	/* read 8 dots into graphics character */
			col = cr + j;
			pd = getpix(col,row);
			if(pd!=bkcol)
			chr += bit;
			bit >>= 1;					/* Shift mask */
			}
			putc(chr,stdprn); putc(chr,stdprn);		/* Two graphics characters */
		}
		putc(0x0a,stdprn); putc(0x0d,stdprn);		/* LF - CR */
	}
	return 1;
	}



/*void main()
{ printer p;graph16c();
   p.printpage(1,1,640,480);
   char ch;
   ch=p.status(0);
   showbits(ch);
   cout<<"\n"<<(int)(ch & 32);
   getch();

   }*/